// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.0
//
// <auto-generated>
//
// Generated from file `Communicator.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//


using _System = global::System;
using _Microsoft = global::Microsoft;

#pragma warning disable 1591

namespace IceCompactId
{
}

namespace Ice
{
    [_System.Runtime.InteropServices.ComVisible(false)]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1704")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1707")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1710")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1711")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1715")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1716")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1720")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1722")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1724")]
    public partial interface Communicator
    {
        #region Slice operations

        
        /// <summary>
        /// Destroy the communicator.
        /// This operation calls shutdown
        /// implicitly.  Calling destroy cleans up memory, and shuts down
        /// this communicator's client functionality and destroys all object
        /// adapters. Subsequent calls to destroy are ignored.
        /// 
        /// </summary>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void destroy();

        
        /// <summary>
        /// Shuts down this communicator's server functionality, which
        /// includes the deactivation of all object adapters.
        /// (Attempts to use
        /// a deactivated object adapter raise ObjectAdapterDeactivatedException.)
        /// Subsequent calls to shutdown are ignored.
        /// 
        ///  After shutdown returns, no new requests are
        /// processed. However, requests that have been started before
        /// shutdown was called might still be active. You can use
        /// waitForShutdown to wait for the completion of all
        /// requests.
        /// 
        /// </summary>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void shutdown();

        
        /// <summary>
        /// Wait until the application has called shutdown (or destroy).
        /// On the server side, this operation blocks the calling thread
        /// until all currently-executing operations have completed.
        /// On the client side, the operation simply block until another
        /// thread has called shutdown or destroy.
        /// 
        /// A typical use of this operation is to call it
        /// from the main thread, which then waits until some other thread
        /// calls shutdown. After shut-down is complete, the main thread
        /// returns and can do some cleanup work before it finally calls
        /// destroy to shut down the client functionality, and then
        /// exits the application.
        /// 
        /// </summary>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void waitForShutdown();

        
        /// <summary>
        /// Check whether communicator has been shut down.
        /// </summary>
        /// <returns>True if the communicator has been shut down; false otherwise.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]bool isShutdown();

        
        /// <summary>
        /// Convert a stringified proxy into a proxy.
        /// For example,
        /// MyCategory/MyObject:tcp -h some_host -p
        /// 10000 creates a proxy that refers to the Ice object
        /// having an identity with a name "MyObject" and a category
        /// "MyCategory", with the server running on host "some_host", port
        /// 10000. If the stringified proxy does not parse correctly, the
        /// operation throws one of ProxyParseException,
        /// EndpointParseException, or IdentityParseException.
        /// An appendix in the Ice manual provides a detailed description
        /// of the syntax supported by stringified proxies.
        /// 
        /// </summary>
        /// <param name="str">The stringified proxy to convert into a proxy.
        /// 
        /// </param>
        /// <returns>The proxy, or nil if str is an empty string.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.ObjectPrx stringToProxy(string str);

        
        /// <summary>
        /// Convert a proxy into a string.
        /// </summary>
        /// <param name="obj">The proxy to convert into a stringified proxy.
        /// 
        /// </param>
        /// <returns>The stringified proxy, or an empty string if
        /// obj is nil.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]string proxyToString(Ice.ObjectPrx obj);

        
        /// <summary>
        /// Convert a set of proxy properties into a proxy.
        /// The "base"
        /// name supplied in the property argument refers to a
        /// property containing a stringified proxy, such as
        /// MyProxy=id:tcp -h localhost -p 10000. Additional
        /// properties configure local settings for the proxy, such as
        /// MyProxy.PreferSecure=1. The "Properties"
        /// appendix in the Ice manual describes each of the supported
        /// proxy properties.
        /// 
        /// </summary>
        /// <param name="property">The base property name.
        /// 
        /// </param>
        /// <returns>The proxy.</returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.ObjectPrx propertyToProxy(string property);

        
        /// <summary>
        /// Convert a proxy to a set of proxy properties.
        /// </summary>
        /// <param name="proxy">The proxy.
        /// 
        /// </param>
        /// <param name="property">The base property name.
        /// 
        /// </param>
        /// <returns>The property set.</returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]_System.Collections.Generic.Dictionary<string, string> proxyToProperty(Ice.ObjectPrx proxy, string property);

        
        /// <summary>
        /// Convert a string into an identity.
        /// If the string does not parse
        /// correctly, the operation throws IdentityParseException.
        /// 
        /// </summary>
        /// <param name="str">The string to convert into an identity.
        /// 
        /// </param>
        /// <returns>The identity.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.Identity stringToIdentity(string str);

        
        /// <summary>
        /// Convert an identity into a string.
        /// </summary>
        /// <param name="ident">The identity to convert into a string.
        /// 
        /// </param>
        /// <returns>The "stringified" identity.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]string identityToString(Ice.Identity ident);

        
        /// <summary>
        /// Create a new object adapter.
        /// The endpoints for the object
        /// adapter are taken from the property name.Endpoints.
        /// 
        /// It is legal to create an object adapter with the empty string as
        /// its name. Such an object adapter is accessible via bidirectional
        /// connections or by collocated invocations that originate from the
        /// same communicator as is used by the adapter.
        /// 
        /// Attempts to create a named object adapter for which no configuration
        /// can be found raise InitializationException.
        /// 
        /// </summary>
        /// <param name="name">The object adapter name.
        /// 
        /// </param>
        /// <returns>The new object adapter.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.ObjectAdapter createObjectAdapter(string name);

        
        /// <summary>
        /// Create a new object adapter with endpoints.
        /// This operation sets
        /// the property name.Endpoints,
        /// and then calls createObjectAdapter. It is provided as a
        /// convenience function.
        /// 
        /// Calling this operation with an empty name will result in a
        /// UUID being generated for the name.
        /// 
        /// </summary>
        /// <param name="name">The object adapter name.
        /// 
        /// </param>
        /// <param name="endpoints">The endpoints for the object adapter.
        /// 
        /// </param>
        /// <returns>The new object adapter.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.ObjectAdapter createObjectAdapterWithEndpoints(string name, string endpoints);

        
        /// <summary>
        /// Create a new object adapter with a router.
        /// This operation
        /// creates a routed object adapter.
        /// 
        /// Calling this operation with an empty name will result in a
        /// UUID being generated for the name.
        /// 
        /// </summary>
        /// <param name="name">The object adapter name.
        /// 
        /// </param>
        /// <param name="rtr">The router.
        /// 
        /// </param>
        /// <returns>The new object adapter.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.ObjectAdapter createObjectAdapterWithRouter(string name, Ice.RouterPrx rtr);

        
        /// <summary>
        /// Add an object factory to this communicator.
        /// Installing a 
        /// factory with an id for which a factory is already registered 
        /// throws AlreadyRegisteredException.
        /// 
        /// When unmarshaling an Ice object, the Ice run time reads the
        /// most-derived type id off the wire and attempts to create an
        /// instance of the type using a factory. If no instance is created,
        /// either because no factory was found, or because all factories
        /// returned nil, the behavior of the Ice run time depends on the
        /// format with which the object was marshaled:
        /// 
        /// If the object uses the "sliced" format, Ice ascends the class
        /// hierarchy until it finds a type that is recognized by a factory,
        /// or it reaches the least-derived type. If no factory is found that
        /// can create an instance, the run time throws
        /// NoObjectFactoryException.
        /// 
        /// If the object uses the "compact" format, Ice immediately raises
        /// NoObjectFactoryException.
        /// 
        /// The following order is used to locate a factory for a type:
        /// 
        /// 
        /// 
        /// The Ice run-time looks for a factory registered
        /// specifically for the type.
        /// 
        /// If no instance has been created, the Ice run-time looks
        /// for the default factory, which is registered with an empty type id.
        /// 
        /// 
        /// If no instance has been created by any of the preceding
        /// steps, the Ice run-time looks for a factory that may have been
        /// statically generated by the language mapping for non-abstract classes.
        /// 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="factory">The factory to add.
        /// 
        /// </param>
        /// <param name="id">The type id for which the factory can create instances, or
        /// an empty string for the default factory.
        /// 
        /// </param>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void addObjectFactory(Ice.ObjectFactory factory, string id);

        
        /// <summary>
        /// Find an object factory registered with this communicator.
        /// </summary>
        /// <param name="id">The type id for which the factory can create instances,
        /// or an empty string for the default factory.
        /// 
        /// </param>
        /// <returns>The object factory, or null if no object factory was
        /// found for the given id.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.ObjectFactory findObjectFactory(string id);

        
        /// <summary>
        /// Get the implicit context associated with this communicator.
        /// </summary>
        /// <returns>The implicit context associated with this communicator;
        /// returns null when the property Ice.ImplicitContext is not set
        /// or is set to None.</returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.ImplicitContext getImplicitContext();

        
        /// <summary>
        /// Get the properties for this communicator.
        /// </summary>
        /// <returns>This communicator's properties.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.Properties getProperties();

        
        /// <summary>
        /// Get the logger for this communicator.
        /// </summary>
        /// <returns>This communicator's logger.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.Logger getLogger();

        
        /// <summary>
        /// Get the statistics callback object for this communicator.
        /// </summary>
        /// <returns>This communicator's statistics callback object.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.Stats getStats();

        
        /// <summary>
        /// Get the observer resolver object for this communicator.
        /// </summary>
        /// <returns>This communicator's observer resolver object.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.Instrumentation.CommunicatorObserver getObserver();

        
        /// <summary>
        /// Get the default router this communicator.
        /// </summary>
        /// <returns>The default router for this communicator.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.RouterPrx getDefaultRouter();

        
        /// <summary>
        /// Set a default router for this communicator.
        /// All newly
        /// created proxies will use this default router. To disable the
        /// default router, null can be used. Note that this
        /// operation has no effect on existing proxies.
        /// 
        /// You can also set a router for an individual proxy
        /// by calling the operation ice_router on the proxy.
        /// 
        /// </summary>
        /// <param name="rtr">The default router to use for this communicator.
        /// 
        /// </param>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void setDefaultRouter(Ice.RouterPrx rtr);

        
        /// <summary>
        /// Get the default locator this communicator.
        /// </summary>
        /// <returns>The default locator for this communicator.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.LocatorPrx getDefaultLocator();

        
        /// <summary>
        /// Set a default Ice locator for this communicator.
        /// All newly
        /// created proxy and object adapters will use this default
        /// locator. To disable the default locator, null can be used.
        /// Note that this operation has no effect on existing proxies or
        /// object adapters.
        /// 
        ///  You can also set a locator for an individual proxy
        /// by calling the operation ice_locator on the proxy, or for an
        /// object adapter by calling the operation setLocator on the
        /// object adapter.
        /// 
        /// </summary>
        /// <param name="loc">The default locator to use for this communicator.
        /// 
        /// </param>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void setDefaultLocator(Ice.LocatorPrx loc);

        
        /// <summary>
        /// Get the plug-in manager for this communicator.
        /// </summary>
        /// <returns>This communicator's plug-in manager.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.PluginManager getPluginManager();

        
        /// <summary>
        /// Flush any pending batch requests for this communicator.
        /// This causes all batch requests that were sent via proxies
        /// obtained via this communicator to be sent to the server.
        /// </summary>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void flushBatchRequests();

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        Ice.AsyncResult begin_flushBatchRequests();

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        Ice.AsyncResult begin_flushBatchRequests(Ice.AsyncCallback cb__, object cookie__);

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        void end_flushBatchRequests(Ice.AsyncResult r__);

        
        /// <summary>
        /// Get a proxy to the main facet of the Admin object.
        /// When Ice.Admin.DelayCreation
        /// is greater than 0, it is necessary to call getAdmin() after the communicator is
        /// initialized to create the Admin object. Otherwise, the Admin object is created
        /// automatically after all the plug-ins are initialized.
        /// 
        /// </summary>
        /// <returns>The main ("") facet of the Admin object; a null proxy if no
        /// Admin object is configured.</returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.ObjectPrx getAdmin();

        
        /// <summary>
        /// Add a new facet to the Admin object.
        /// Adding a servant with a facet that is already registered 
        /// throws AlreadyRegisteredException.
        /// 
        /// </summary>
        /// <param name="servant">The servant that implements the new Admin facet.
        /// </param>
        /// <param name="facet">The name of the new Admin facet.</param>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void addAdminFacet(Ice.Object servant, string facet);

        
        /// <summary>
        /// Remove the following facet to the Admin object.
        /// Removing a facet that was not previously registered throws 
        /// NotRegisteredException.
        /// 
        /// </summary>
        /// <param name="facet">The name of the Admin facet.
        /// </param>
        /// <returns>The servant associated with this Admin facet.</returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.Object removeAdminFacet(string facet);

        
        /// <summary>
        /// Returns a facet of the Admin object.
        /// </summary>
        /// <param name="facet">The name of the Admin facet.
        /// </param>
        /// <returns>The servant associated with this Admin facet, or
        /// null if no facet is registered with the given name.</returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.Object findAdminFacet(string facet);

        #endregion
    }
}

namespace Ice
{
}

namespace Ice
{
}
