// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.0
//
// <auto-generated>
//
// Generated from file `Connection.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//


using _System = global::System;
using _Microsoft = global::Microsoft;

#pragma warning disable 1591

namespace IceCompactId
{
}

namespace Ice
{
    [_System.Runtime.InteropServices.ComVisible(false)]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1704")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1707")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1710")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1711")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1715")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1716")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1720")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1722")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1724")]
    public partial class ConnectionInfo
    {
        #region Slice data members

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        public bool incoming;

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        public string adapterName;

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        public string connectionId;

        #endregion

        #region Constructors

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        public ConnectionInfo()
        {
        }

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        public ConnectionInfo(bool incoming, string adapterName, string connectionId)
        {
            this.incoming = incoming;
            this.adapterName = adapterName;
            this.connectionId = connectionId;
        }

        #endregion
    }

    [_System.Runtime.InteropServices.ComVisible(false)]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1704")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1707")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1710")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1711")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1715")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1716")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1720")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1722")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1724")]
    public partial interface Connection
    {
        #region Slice operations

        
        /// <summary>
        /// Close a connection, either gracefully or forcefully.
        /// If a
        /// connection is closed forcefully, it closes immediately, without
        /// sending the relevant close connection protocol messages to the
        /// peer and waiting for the peer to acknowledge these protocol
        /// messages.
        /// 
        /// </summary>
        /// <param name="force">If true, close forcefully. Otherwise the
        /// connection is closed gracefully.</param>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void close(bool force);

        
        /// <summary>
        /// Create a special proxy that always uses this connection.
        /// This
        /// can be used for callbacks from a server to a client if the
        /// server cannot directly establish a connection to the client,
        /// for example because of firewalls. In this case, the server
        /// would create a proxy using an already established connection
        /// from the client.
        /// 
        /// </summary>
        /// <param name="id">The identity for which a proxy is to be created.
        /// 
        /// </param>
        /// <returns>A proxy that matches the given identity and uses this
        /// connection.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.ObjectPrx createProxy(Ice.Identity id);

        
        /// <summary>
        /// Explicitly set an object adapter that dispatches requests that
        /// are received over this connection.
        /// A client can invoke an
        /// operation on a server using a proxy, and then set an object
        /// adapter for the outgoing connection that is used by the proxy
        /// in order to receive callbacks. This is useful if the server
        /// cannot establish a connection back to the client, for example
        /// because of firewalls.
        /// 
        /// </summary>
        /// <param name="adapter">The object adapter that should be used by this
        /// connection to dispatch requests. The object adapter must be
        /// activated. When the object adapter is deactivated, it is
        /// automatically removed from the connection.
        /// 
        /// </param>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void setAdapter(Ice.ObjectAdapter adapter);

        
        /// <summary>
        /// Get the object adapter that dispatches requests for this
        /// connection.
        /// </summary>
        /// <returns>The object adapter that dispatches requests for the
        /// connection, or null if no adapter is set.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.ObjectAdapter getAdapter();

        
        /// <summary>
        /// Get the endpoint from which the connection was created.
        /// </summary>
        /// <returns>The endpoint from which the connection was created.</returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.Endpoint getEndpoint();

        
        /// <summary>
        /// Flush any pending batch requests for this connection.
        /// This
        /// causes all batch requests that were sent via proxies that use
        /// this connection to be sent to the server.
        /// </summary>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void flushBatchRequests();

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        Ice.AsyncResult begin_flushBatchRequests();

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        Ice.AsyncResult begin_flushBatchRequests(Ice.AsyncCallback cb__, object cookie__);

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        void end_flushBatchRequests(Ice.AsyncResult r__);

        
        /// <summary>
        /// Return the connection type.
        /// This corresponds to the endpoint
        /// type, i.e., "tcp", "udp", etc.
        /// 
        /// </summary>
        /// <returns>The type of the connection.</returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]string type();

        
        /// <summary>
        /// Get the timeout for the connection.
        /// </summary>
        /// <returns>The connection's timeout.</returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]int timeout();

        
        /// <summary>
        /// Return a description of the connection as human readable text,
        /// suitable for logging or error messages.
        /// </summary>
        /// <returns>The description of the connection as human readable
        /// text.</returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]string ice_toString_();

        
        /// <summary>
        /// Returns the connection information.
        /// </summary>
        /// <returns>The connection information.</returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.ConnectionInfo getInfo();

        #endregion
    }

    [_System.Runtime.InteropServices.ComVisible(false)]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1704")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1707")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1710")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1711")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1715")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1716")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1720")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1722")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1724")]
    public partial class IPConnectionInfo : Ice.ConnectionInfo
    {
        #region Slice data members

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        public string localAddress;

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        public int localPort;

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        public string remoteAddress;

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        public int remotePort;

        #endregion

        #region Constructors

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        public IPConnectionInfo() : base()
        {
            this.localAddress = "";
            this.localPort = -1;
            this.remoteAddress = "";
            this.remotePort = -1;
        }

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        public IPConnectionInfo(bool incoming, string adapterName, string connectionId, string localAddress, int localPort, string remoteAddress, int remotePort) : base(incoming, adapterName, connectionId)
        {
            this.localAddress = localAddress;
            this.localPort = localPort;
            this.remoteAddress = remoteAddress;
            this.remotePort = remotePort;
        }

        #endregion
    }

    [_System.Runtime.InteropServices.ComVisible(false)]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1704")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1707")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1710")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1711")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1715")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1716")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1720")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1722")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1724")]
    public partial class TCPConnectionInfo : Ice.IPConnectionInfo
    {
        #region Constructors

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        public TCPConnectionInfo() : base()
        {
        }

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        public TCPConnectionInfo(bool incoming, string adapterName, string connectionId, string localAddress, int localPort, string remoteAddress, int remotePort) : base(incoming, adapterName, connectionId, localAddress, localPort, remoteAddress, remotePort)
        {
        }

        #endregion
    }

    [_System.Runtime.InteropServices.ComVisible(false)]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1704")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1707")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1710")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1711")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1715")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1716")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1720")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1722")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1724")]
    public partial class UDPConnectionInfo : Ice.IPConnectionInfo
    {
        #region Slice data members

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        public string mcastAddress;

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        public int mcastPort;

        #endregion

        #region Constructors

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        public UDPConnectionInfo() : base()
        {
            this.mcastPort = -1;
        }

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        public UDPConnectionInfo(bool incoming, string adapterName, string connectionId, string localAddress, int localPort, string remoteAddress, int remotePort, string mcastAddress, int mcastPort) : base(incoming, adapterName, connectionId, localAddress, localPort, remoteAddress, remotePort)
        {
            this.mcastAddress = mcastAddress;
            this.mcastPort = mcastPort;
        }

        #endregion
    }
}

namespace Ice
{
}

namespace Ice
{
}
