// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.0
//
// <auto-generated>
//
// Generated from file `Instrumentation.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//


using _System = global::System;
using _Microsoft = global::Microsoft;

#pragma warning disable 1591

namespace IceCompactId
{
}

namespace Ice
{
    namespace Instrumentation
    {
        [_System.Runtime.InteropServices.ComVisible(false)]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1704")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1707")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1710")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1711")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1715")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1716")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1720")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1722")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1724")]
        public partial interface Observer
        {
            #region Slice operations

            
            /// <summary>
            /// This method is called when the instrumented object is created
            /// or when the observer is attached to an existing object.
            /// </summary>
            
            [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void attach();

            
            /// <summary>
            /// This method is called when the instrumented object is destroyed
            /// and as a result the observer detached from the object.
            /// </summary>
            
            [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void detach();

            
            /// <summary>
            /// Notification of a failure.
            /// </summary>
            /// <param name="exceptionName">The name of the exception.</param>
            
            [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void failed(string exceptionName);

            #endregion
        }

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        public enum ThreadState
        {
            ThreadStateIdle,
            ThreadStateInUseForIO,
            ThreadStateInUseForUser,
            ThreadStateInUseForOther
        }

        [_System.Runtime.InteropServices.ComVisible(false)]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1704")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1707")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1710")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1711")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1715")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1716")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1720")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1722")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1724")]
        public partial interface ThreadObserver : Ice.Instrumentation.Observer
        {
            #region Slice operations

            
            /// <summary>
            /// Notification of thread state change.
            /// </summary>
            /// <param name="oldState">The previous thread state.
            /// 
            /// </param>
            /// <param name="newState">The new thread state.</param>
            
            [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void stateChanged(Ice.Instrumentation.ThreadState oldState, Ice.Instrumentation.ThreadState newState);

            #endregion
        }

        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
        public enum ConnectionState
        {
            ConnectionStateValidating,
            ConnectionStateHolding,
            ConnectionStateActive,
            ConnectionStateClosing,
            ConnectionStateClosed
        }

        [_System.Runtime.InteropServices.ComVisible(false)]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1704")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1707")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1710")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1711")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1715")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1716")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1720")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1722")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1724")]
        public partial interface ConnectionObserver : Ice.Instrumentation.Observer
        {
            #region Slice operations

            
            /// <summary>
            /// Notification of sent bytes over the connection.
            /// </summary>
            /// <param name="num">The number of bytes sent.</param>
            
            [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void sentBytes(int num);

            
            /// <summary>
            /// Notification of received bytes over the connection.
            /// </summary>
            /// <param name="num">The number of bytes received.</param>
            
            [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void receivedBytes(int num);

            #endregion
        }

        [_System.Runtime.InteropServices.ComVisible(false)]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1704")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1707")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1710")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1711")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1715")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1716")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1720")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1722")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1724")]
        public partial interface DispatchObserver : Ice.Instrumentation.Observer
        {
            #region Slice operations

            
            /// <summary>
            /// Notification of a user exception.
            /// </summary>
            
            [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void userException();

            
            /// <summary>
            /// Reply notification.
            /// </summary>
            /// <param name="size">The size of the reply.</param>
            
            [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void reply(int size);

            #endregion
        }

        [_System.Runtime.InteropServices.ComVisible(false)]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1704")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1707")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1710")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1711")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1715")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1716")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1720")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1722")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1724")]
        public partial interface RemoteObserver : Ice.Instrumentation.Observer
        {
            #region Slice operations

            
            /// <summary>
            /// Reply notification.
            /// </summary>
            /// <param name="size">The size of the reply.</param>
            
            [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void reply(int size);

            #endregion
        }

        [_System.Runtime.InteropServices.ComVisible(false)]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1704")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1707")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1710")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1711")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1715")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1716")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1720")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1722")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1724")]
        public partial interface InvocationObserver : Ice.Instrumentation.Observer
        {
            #region Slice operations

            
            /// <summary>
            /// Notification of the invocation being retried.
            /// </summary>
            
            [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void retried();

            
            /// <summary>
            /// Notification of a user exception.
            /// </summary>
            
            [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void userException();

            
            /// <summary>
            /// Get a remote observer for this invocation.
            /// </summary>
            /// <param name="con">The connection information.
            /// 
            /// </param>
            /// <param name="endpt">The connection endpoint.
            /// 
            /// </param>
            /// <param name="requestId">The ID of the invocation.
            /// 
            /// </param>
            /// <param name="size">The size of the invocation.
            /// 
            /// </param>
            /// <returns>The observer to instrument the remote invocation.</returns>
            
            [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.Instrumentation.RemoteObserver getRemoteObserver(Ice.ConnectionInfo con, Ice.Endpoint endpt, int requestId, int size);

            #endregion
        }

        [_System.Runtime.InteropServices.ComVisible(false)]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1704")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1707")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1710")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1711")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1715")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1716")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1720")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1722")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1724")]
        public partial interface ObserverUpdater
        {
            #region Slice operations

            
            /// <summary>
            /// Update connection observers associated with each of the Ice
            /// connection from the communicator and its object adapters.
            /// When called, this method goes through all the connections and
            /// for each connection CommunicatorObserver.getConnectionObserver
            /// is called. The implementation of getConnectionObserver has the
            /// possibility to return an updated observer if necessary.
            /// </summary>
            
            [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void updateConnectionObservers();

            
            /// <summary>
            /// Update thread observers associated with each of the Ice thread
            /// from the communicator and its object adapters.
            /// When called, this method goes through all the threads and for
            /// each thread CommunicatorObserver.getThreadObserver is
            /// called. The implementation of getThreadObserver has the
            /// possibility to return an updated observer if necessary.
            /// </summary>
            
            [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void updateThreadObservers();

            #endregion
        }

        [_System.Runtime.InteropServices.ComVisible(false)]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1704")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1707")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1710")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1711")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1715")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1716")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1720")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1722")]
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1724")]
        public partial interface CommunicatorObserver
        {
            #region Slice operations

            
            /// <summary>
            /// This method should return an observer for the given endpoint
            /// information and connector.
            /// The Ice run-time calls this method
            /// for each connection establishment attempt.
            /// 
            /// </summary>
            /// <param name="endpt">The endpoint.
            /// 
            /// </param>
            /// <param name="connector">The description of the connector. For IP
            /// transports, this is typically the IP address to connect to.
            /// 
            /// </param>
            /// <returns>The observer to instrument the connection establishment.</returns>
            
            [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.Instrumentation.Observer getConnectionEstablishmentObserver(Ice.Endpoint endpt, string connector);

            
            /// <summary>
            /// This method should return an observer for the given endpoint
            /// information.
            /// The Ice run-time calls this method to resolve an
            /// endpoint and obtain the list of connectors. 
            /// 
            /// For IP endpoints, this typically involves doing a DNS lookup to
            /// obtain the IP addresses associated with the DNS name.
            /// 
            /// </summary>
            /// <param name="endpt">The endpoint.
            /// 
            /// </param>
            /// <returns>The observer to instrument the endpoint lookup.</returns>
            
            [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.Instrumentation.Observer getEndpointLookupObserver(Ice.Endpoint endpt);

            
            /// <summary>
            /// This method should return a connection observer for the given
            /// connection.
            /// The Ice run-time calls this method for each new
            /// connection and for all the Ice communicator connections when
            /// ObserverUpdater.updateConnections is called.
            /// 
            /// </summary>
            /// <param name="c">The connection information.
            /// 
            /// </param>
            /// <param name="e">The connection endpoint.
            /// 
            /// </param>
            /// <param name="s">The state of the connection.
            /// 
            /// </param>
            /// <param name="o">The old connection observer if one is already set or a
            /// null reference otherwise.
            /// 
            /// </param>
            /// <returns>The connection observer to instrument the connection.</returns>
            
            [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.Instrumentation.ConnectionObserver getConnectionObserver(Ice.ConnectionInfo c, Ice.Endpoint e, Ice.Instrumentation.ConnectionState s, Ice.Instrumentation.ConnectionObserver o);

            
            /// <summary>
            /// This method should return a thread observer for the given
            /// thread.
            /// The Ice run-time calls this method for each new thread
            /// and for all the Ice communicator threads when
            /// ObserverUpdater.updateThreads is called.
            /// 
            /// </summary>
            /// <param name="parent">The parent of the thread.
            /// 
            /// </param>
            /// <param name="id">The ID of the thread to observe.
            /// 
            /// </param>
            /// <param name="s">The state of the thread.
            /// 
            /// </param>
            /// <param name="o">The old thread observer if one is already set or a
            /// null reference otherwise.
            /// 
            /// </param>
            /// <returns>The thread observer to instrument the thread.</returns>
            
            [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.Instrumentation.ThreadObserver getThreadObserver(string parent, string id, Ice.Instrumentation.ThreadState s, Ice.Instrumentation.ThreadObserver o);

            
            /// <summary>
            /// This method should return an invocation observer for the given
            /// invocation.
            /// The Ice run-time calls this method for each new
            /// invocation on a proxy.
            /// 
            /// </summary>
            /// <param name="prx">The proxy used for the invocation.
            /// 
            /// </param>
            /// <param name="operation">The name of the invocation.
            /// 
            /// </param>
            /// <param name="ctx">The context specified by the user.
            /// 
            /// </param>
            /// <returns>The invocation observer to instrument the invocation.</returns>
            
            [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.Instrumentation.InvocationObserver getInvocationObserver(Ice.ObjectPrx prx, string operation, _System.Collections.Generic.Dictionary<string, string> ctx);

            
            /// <summary>
            /// This method should return a dispatch observer for the given
            /// dispatch.
            /// The Ice run-time calls this method each time it
            /// receives an incoming invocation to be dispatched for an Ice
            /// object.
            /// 
            /// </summary>
            /// <param name="c">The current object as provided to the Ice servant
            /// dispatching the invocation.
            /// 
            /// </param>
            /// <param name="size">The size of the dispatch.
            /// 
            /// </param>
            /// <returns>The dispatch observer to instrument the dispatch.</returns>
            
            [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.Instrumentation.DispatchObserver getDispatchObserver(Ice.Current c, int size);

            
            /// <summary>
            /// The Ice run-time calls this method when the communicator is
            /// initialized.
            /// The add-in implementing this interface can use
            /// this object to get the Ice run-time to re-obtain observers for
            /// observed objects.
            /// 
            /// </summary>
            /// <param name="updater">The observer updater object.</param>
            
            [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void setObserverUpdater(Ice.Instrumentation.ObserverUpdater updater);

            #endregion
        }
    }
}

namespace Ice
{
    namespace Instrumentation
    {
    }
}

namespace Ice
{
    namespace Instrumentation
    {
    }
}
