// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.0
//
// <auto-generated>
//
// Generated from file `Plugin.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//


using _System = global::System;
using _Microsoft = global::Microsoft;

#pragma warning disable 1591

namespace IceCompactId
{
}

namespace Ice
{
    [_System.Runtime.InteropServices.ComVisible(false)]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1704")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1707")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1710")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1711")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1715")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1716")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1720")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1722")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1724")]
    public partial interface Plugin
    {
        #region Slice operations

        
        /// <summary>
        /// Perform any necessary initialization steps.
        /// </summary>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void initialize();

        
        /// <summary>
        /// Called when the communicator is being destroyed.
        /// </summary>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void destroy();

        #endregion
    }

    [_System.Runtime.InteropServices.ComVisible(false)]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1704")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1707")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1710")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1711")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1715")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1716")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1720")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1722")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1724")]
    public partial interface PluginManager
    {
        #region Slice operations

        
        /// <summary>
        /// Initialize the configured plug-ins.
        /// The communicator automatically initializes
        /// the plug-ins by default, but an application may need to interact directly with
        /// a plug-in prior to initialization. In this case, the application must set
        /// Ice.InitPlugins=0 and then invoke initializePlugins
        /// manually. The plug-ins are initialized in the order in which they are loaded.
        /// If a plug-in raises an exception during initialization, the communicator
        /// invokes destroy on the plug-ins that have already been initialized.
        /// 
        /// </summary>
        /// <exception name="InitializationException">Raised if the plug-ins have already been initialized.</exception>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void initializePlugins();

        
        /// <summary>
        /// Get a list of plugins installed.
        /// </summary>
        /// <returns>The names of the plugins installed.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]string[] getPlugins();

        
        /// <summary>
        /// Obtain a plug-in by name.
        /// </summary>
        /// <param name="name">The plug-in's name.
        /// 
        /// </param>
        /// <returns>The plug-in.
        /// 
        /// </returns>
        /// <exception name="NotRegisteredException">Raised if no plug-in is found with the given name.</exception>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.Plugin getPlugin(string name);

        
        /// <summary>
        /// Install a new plug-in.
        /// </summary>
        /// <param name="name">The plug-in's name.
        /// 
        /// </param>
        /// <param name="pi">The plug-in.
        /// 
        /// </param>
        /// <exception name="AlreadyRegisteredException">Raised if a plug-in already exists with the given name.</exception>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void addPlugin(string name, Ice.Plugin pi);

        
        /// <summary>
        /// Called when the communicator is being destroyed.
        /// </summary>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void destroy();

        #endregion
    }
}

namespace Ice
{
}

namespace Ice
{
}
