// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.0
//
// <auto-generated>
//
// Generated from file `Properties.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//


using _System = global::System;
using _Microsoft = global::Microsoft;

#pragma warning disable 1591

namespace IceCompactId
{
}

namespace Ice
{
    [_System.Runtime.InteropServices.ComVisible(false)]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1704")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1707")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1710")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1711")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1715")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1716")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1720")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1722")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1724")]
    public partial interface Properties
    {
        #region Slice operations

        
        /// <summary>
        /// Get a property by key.
        /// If the property is not set, an empty
        /// string is returned.
        /// 
        /// </summary>
        /// <param name="key">The property key.
        /// 
        /// </param>
        /// <returns>The property value.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]string getProperty(string key);

        
        /// <summary>
        /// Get a property by key.
        /// If the property is not set, the
        /// given default value is returned.
        /// 
        /// </summary>
        /// <param name="key">The property key.
        /// 
        /// </param>
        /// <param name="value">The default value to use if the property does not
        /// exist.
        /// 
        /// </param>
        /// <returns>The property value or the default value.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]string getPropertyWithDefault(string key, string value);

        
        /// <summary>
        /// Get a property as an integer.
        /// If the property is not set, 0
        /// is returned.
        /// 
        /// </summary>
        /// <param name="key">The property key.
        /// 
        /// </param>
        /// <returns>The property value interpreted as an integer.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]int getPropertyAsInt(string key);

        
        /// <summary>
        /// Get a property as an integer.
        /// If the property is not set, the
        /// given default value is returned.
        /// 
        /// </summary>
        /// <param name="key">The property key.
        /// 
        /// </param>
        /// <param name="value">The default value to use if the property does not
        /// exist.
        /// 
        /// </param>
        /// <returns>The property value interpreted as an integer, or the
        /// default value.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]int getPropertyAsIntWithDefault(string key, int value);

        
        /// <summary>
        /// Get a property as a list of strings.
        /// If the property is not set,
        /// an empty list is returned. The strings in the list can contain
        /// whitespace if they are enclosed in single or double quotes.
        /// If quotes are mismatched, an empty list is returned.
        /// Within single quotes or double-quotes, you can escape the
        /// quote in question with \, e.g. O'Reilly can be written as
        /// O'Reilly, "O'Reilly" or 'O\'Reilly'.
        /// 
        /// </summary>
        /// <param name="key">The property key.
        /// 
        /// </param>
        /// <returns>The property value interpreted as a list of strings.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]string[] getPropertyAsList(string key);

        
        /// <summary>
        /// Get a property as a list of strings.
        /// If the property is not set,
        /// the default list is returned. The strings in the list can contain
        /// whitespace if they are enclosed in single or double quotes.
        /// If quotes are mismatched, the default list is returned.
        /// Within single quotes or double-quotes, you can escape the
        /// quote in question with \, e.g. O'Reilly can be written as
        /// O'Reilly, "O'Reilly" or 'O\'Reilly'.
        /// 
        /// </summary>
        /// <param name="key">The property key.
        /// 
        /// </param>
        /// <param name="value">The default value to use if the property is not set.
        /// 
        /// </param>
        /// <returns>The property value interpreted as list of strings, or the
        /// default value.
        /// 
        /// </returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]string[] getPropertyAsListWithDefault(string key, string[] value);

        
        /// <summary>
        /// Get all properties whose keys begins with
        /// prefix.
        /// If
        /// prefix is an empty string,
        /// then all properties are returned.
        /// 
        /// </summary>
        /// <param name="prefix">The prefix to search for (empty string if none).
        /// </param>
        /// <returns>The matching property set.</returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]_System.Collections.Generic.Dictionary<string, string> getPropertiesForPrefix(string prefix);

        
        /// <summary>
        /// Set a property.
        /// To unset a property, set it to
        /// the empty string.
        /// 
        /// </summary>
        /// <param name="key">The property key.
        /// </param>
        /// <param name="value">The property value.
        /// 
        /// </param>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void setProperty(string key, string value);

        
        /// <summary>
        /// Get a sequence of command-line options that is equivalent to
        /// this property set.
        /// Each element of the returned sequence is
        /// a command-line option of the form
        /// --key=value.
        /// 
        /// </summary>
        /// <returns>The command line options for this property set.</returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]string[] getCommandLineOptions();

        
        /// <summary>
        /// Convert a sequence of command-line options into properties.
        /// All options that begin with
        /// --prefix. are
        /// converted into properties. If the prefix is empty, all options
        /// that begin with -- are converted to properties.
        /// 
        /// </summary>
        /// <param name="prefix">The property prefix, or an empty string to
        /// convert all options starting with --.
        /// 
        /// </param>
        /// <param name="options">The command-line options.
        /// 
        /// </param>
        /// <returns>The command-line options that do not start with the specified
        /// prefix, in their original order.</returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]string[] parseCommandLineOptions(string prefix, string[] options);

        
        /// <summary>
        /// Convert a sequence of command-line options into properties.
        /// All options that begin with one of the following prefixes
        /// are converted into properties: --Ice, --IceBox, --IceGrid,
        /// --IcePatch2, --IceSSL, --IceStorm, --Freeze, and --Glacier2.
        /// 
        /// </summary>
        /// <param name="options">The command-line options.
        /// 
        /// </param>
        /// <returns>The command-line options that do not start with one of
        /// the listed prefixes, in their original order.</returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]string[] parseIceCommandLineOptions(string[] options);

        
        /// <summary>
        /// Load properties from a file.
        /// </summary>
        /// <param name="file">The property file.</param>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]void load(string file);

        
        /// <summary>
        /// Create a copy of this property set.
        /// </summary>
        /// <returns>A copy of this property set.</returns>
        
        [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]Ice.Properties ice_clone_();

        #endregion
    }

    [_System.Runtime.InteropServices.ComVisible(false)]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1704")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1707")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1709")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1710")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1711")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1715")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1716")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1720")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1722")]
    [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Naming", "CA1724")]
    public partial interface PropertiesAdmin : Ice.Object, PropertiesAdminOperations_, PropertiesAdminOperationsNC_
    {
    }
}

namespace Ice
{
    [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
    public delegate void Callback_PropertiesAdmin_getProperty(string ret__);

    [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
    public delegate void Callback_PropertiesAdmin_getPropertiesForPrefix(_System.Collections.Generic.Dictionary<string, string> ret__);

    [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
    public delegate void Callback_PropertiesAdmin_setProperties();
}

namespace Ice
{
    [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
    public interface PropertiesAdminPrx : Ice.ObjectPrx
    {
        string getProperty(string key);
        string getProperty(string key, _System.Collections.Generic.Dictionary<string, string> context__);

        Ice.AsyncResult<Ice.Callback_PropertiesAdmin_getProperty> begin_getProperty(string key);
        Ice.AsyncResult<Ice.Callback_PropertiesAdmin_getProperty> begin_getProperty(string key, _System.Collections.Generic.Dictionary<string, string> ctx__);

        Ice.AsyncResult begin_getProperty(string key, Ice.AsyncCallback cb__, object cookie__);
        Ice.AsyncResult begin_getProperty(string key, _System.Collections.Generic.Dictionary<string, string> ctx__, Ice.AsyncCallback cb__, object cookie__);

        string end_getProperty(Ice.AsyncResult r__);

        _System.Collections.Generic.Dictionary<string, string> getPropertiesForPrefix(string prefix);
        _System.Collections.Generic.Dictionary<string, string> getPropertiesForPrefix(string prefix, _System.Collections.Generic.Dictionary<string, string> context__);

        Ice.AsyncResult<Ice.Callback_PropertiesAdmin_getPropertiesForPrefix> begin_getPropertiesForPrefix(string prefix);
        Ice.AsyncResult<Ice.Callback_PropertiesAdmin_getPropertiesForPrefix> begin_getPropertiesForPrefix(string prefix, _System.Collections.Generic.Dictionary<string, string> ctx__);

        Ice.AsyncResult begin_getPropertiesForPrefix(string prefix, Ice.AsyncCallback cb__, object cookie__);
        Ice.AsyncResult begin_getPropertiesForPrefix(string prefix, _System.Collections.Generic.Dictionary<string, string> ctx__, Ice.AsyncCallback cb__, object cookie__);

        _System.Collections.Generic.Dictionary<string, string> end_getPropertiesForPrefix(Ice.AsyncResult r__);

        void setProperties(_System.Collections.Generic.Dictionary<string, string> newProperties);
        void setProperties(_System.Collections.Generic.Dictionary<string, string> newProperties, _System.Collections.Generic.Dictionary<string, string> context__);

        Ice.AsyncResult<Ice.Callback_PropertiesAdmin_setProperties> begin_setProperties(_System.Collections.Generic.Dictionary<string, string> newProperties);
        Ice.AsyncResult<Ice.Callback_PropertiesAdmin_setProperties> begin_setProperties(_System.Collections.Generic.Dictionary<string, string> newProperties, _System.Collections.Generic.Dictionary<string, string> ctx__);

        Ice.AsyncResult begin_setProperties(_System.Collections.Generic.Dictionary<string, string> newProperties, Ice.AsyncCallback cb__, object cookie__);
        Ice.AsyncResult begin_setProperties(_System.Collections.Generic.Dictionary<string, string> newProperties, _System.Collections.Generic.Dictionary<string, string> ctx__, Ice.AsyncCallback cb__, object cookie__);

        void end_setProperties(Ice.AsyncResult r__);
    }
}

namespace Ice
{
    /// <summary>
    /// The PropertiesAdmin interface provides remote access to the properties
    /// of a communicator.
    /// </summary>
    
    [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
    public interface PropertiesAdminOperations_
    {
        /// <summary>
        /// Get a property by key.
        /// If the property is not set, an empty
        /// string is returned.
        /// 
        /// </summary>
        /// <param name="key">The property key.
        /// 
        /// </param>
        /// <returns>The property value.</returns>
        /// <param name="current__">The Current object for the invocation.</param>
        
        string getProperty(string key, Ice.Current current__);

        /// <summary>
        /// Get all properties whose keys begin with prefix.
        /// If
        /// prefix is an empty string then all properties are returned.
        /// 
        /// </summary>
        /// <param name="prefix">The prefix to search for (empty string if none).
        /// </param>
        /// <returns>The matching property set.</returns>
        /// <param name="current__">The Current object for the invocation.</param>
        
        _System.Collections.Generic.Dictionary<string, string> getPropertiesForPrefix(string prefix, Ice.Current current__);

        /// <summary>
        /// Update the communicator's properties with the given property set.
        /// </summary>
        /// <param name="cb__">The callback object for the operation.</param>
        /// <param name="newProperties">Properties to be added, changed, or removed.
        /// If an entry in newProperties matches the name of an existing property,
        /// that property's value is replaced with the new value. If the new value
        /// is an empty string, the property is removed. Any existing properties
        /// that are not modified or removed by the entries in newProperties are
        /// retained with their original values.</param>
        /// <param name="current__">The Current object for the invocation.</param>
        void setProperties_async(Ice.AMD_PropertiesAdmin_setProperties cb__, _System.Collections.Generic.Dictionary<string, string> newProperties, Ice.Current current__);
    }

    /// <summary>
    /// The PropertiesAdmin interface provides remote access to the properties
    /// of a communicator.
    /// </summary>
    
    [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
    public interface PropertiesAdminOperationsNC_
    {
        /// <summary>
        /// Get a property by key.
        /// If the property is not set, an empty
        /// string is returned.
        /// 
        /// </summary>
        /// <param name="key">The property key.
        /// 
        /// </param>
        /// <returns>The property value.</returns>
        
        string getProperty(string key);

        /// <summary>
        /// Get all properties whose keys begin with prefix.
        /// If
        /// prefix is an empty string then all properties are returned.
        /// 
        /// </summary>
        /// <param name="prefix">The prefix to search for (empty string if none).
        /// </param>
        /// <returns>The matching property set.</returns>
        
        _System.Collections.Generic.Dictionary<string, string> getPropertiesForPrefix(string prefix);

        /// <summary>
        /// Update the communicator's properties with the given property set.
        /// </summary>
        /// <param name="cb__">The callback object for the operation.</param>
        /// <param name="newProperties">Properties to be added, changed, or removed.
        /// If an entry in newProperties matches the name of an existing property,
        /// that property's value is replaced with the new value. If the new value
        /// is an empty string, the property is removed. Any existing properties
        /// that are not modified or removed by the entries in newProperties are
        /// retained with their original values.</param>
        void setProperties_async(Ice.AMD_PropertiesAdmin_setProperties cb__, _System.Collections.Generic.Dictionary<string, string> newProperties);
    }
}

namespace Ice
{
    [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
    public sealed class PropertyDictHelper
    {
        public static void write(IceInternal.BasicStream os__,
                                 _System.Collections.Generic.Dictionary<string, string> v__)
        {
            if(v__ == null)
            {
                os__.writeSize(0);
            }
            else
            {
                os__.writeSize(v__.Count);
                foreach(_System.Collections.Generic.KeyValuePair<string, string> e__ in v__)
                {
                    os__.writeString(e__.Key);
                    os__.writeString(e__.Value);
                }
            }
        }

        public static _System.Collections.Generic.Dictionary<string, string> read(IceInternal.BasicStream is__)
        {
            int sz__ = is__.readSize();
            _System.Collections.Generic.Dictionary<string, string> r__ = new _System.Collections.Generic.Dictionary<string, string>();
            for(int i__ = 0; i__ < sz__; ++i__)
            {
                string k__;
                k__ = is__.readString();
                string v__;
                v__ = is__.readString();
                r__[k__] = v__;
            }
            return r__;
        }
    }

    /// <summary>
    /// The PropertiesAdmin interface provides remote access to the properties
    /// of a communicator.
    /// </summary>
    
    [_System.Runtime.InteropServices.ComVisible(false)]
    [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
    public sealed class PropertiesAdminPrxHelper : Ice.ObjectPrxHelperBase, PropertiesAdminPrx
    {
        #region Synchronous operations

        /// <summary>
        /// Get all properties whose keys begin with prefix.
        /// If
        /// prefix is an empty string then all properties are returned.
        /// 
        /// </summary>
        /// <param name="prefix">The prefix to search for (empty string if none).
        /// </param>
        /// <returns>The matching property set.</returns>
        
        public _System.Collections.Generic.Dictionary<string, string> getPropertiesForPrefix(string prefix)
        {
            return getPropertiesForPrefix(prefix, null, false);
        }

        /// <summary>
        /// Get all properties whose keys begin with prefix.
        /// If
        /// prefix is an empty string then all properties are returned.
        /// 
        /// </summary>
        /// <param name="prefix">The prefix to search for (empty string if none).
        /// </param>
        /// <returns>The matching property set.</returns>
        /// <param name="context__">The Context map to send with the invocation.</param>
        
        public _System.Collections.Generic.Dictionary<string, string> getPropertiesForPrefix(string prefix, _System.Collections.Generic.Dictionary<string, string> context__)
        {
            return getPropertiesForPrefix(prefix, context__, true);
        }

        private _System.Collections.Generic.Dictionary<string, string> getPropertiesForPrefix(string prefix, _System.Collections.Generic.Dictionary<string, string> context__, bool explicitContext__)
        {
            if(explicitContext__ && context__ == null)
            {
                context__ = emptyContext_;
            }
            Ice.Instrumentation.InvocationObserver observer__ = IceInternal.ObserverHelper.get(this, __getPropertiesForPrefix_name, context__);
            int cnt__ = 0;
            try
            {
                while(true)
                {
                    Ice.ObjectDel_ delBase__ = null;
                    try
                    {
                        checkTwowayOnly__(__getPropertiesForPrefix_name);
                        delBase__ = getDelegate__(false);
                        PropertiesAdminDel_ del__ = (PropertiesAdminDel_)delBase__;
                        return del__.getPropertiesForPrefix(prefix, context__, observer__);
                    }
                    catch(IceInternal.LocalExceptionWrapper ex__)
                    {
                        handleExceptionWrapper__(delBase__, ex__, observer__);
                    }
                    catch(Ice.LocalException ex__)
                    {
                        handleException__(delBase__, ex__, true, ref cnt__, observer__);
                    }
                }
            }
            finally
            {
                if(observer__ != null)
                {
                    observer__.detach();
                }
            }
        }

        /// <summary>
        /// Get a property by key.
        /// If the property is not set, an empty
        /// string is returned.
        /// 
        /// </summary>
        /// <param name="key">The property key.
        /// 
        /// </param>
        /// <returns>The property value.</returns>
        
        public string getProperty(string key)
        {
            return getProperty(key, null, false);
        }

        /// <summary>
        /// Get a property by key.
        /// If the property is not set, an empty
        /// string is returned.
        /// 
        /// </summary>
        /// <param name="key">The property key.
        /// 
        /// </param>
        /// <returns>The property value.</returns>
        /// <param name="context__">The Context map to send with the invocation.</param>
        
        public string getProperty(string key, _System.Collections.Generic.Dictionary<string, string> context__)
        {
            return getProperty(key, context__, true);
        }

        private string getProperty(string key, _System.Collections.Generic.Dictionary<string, string> context__, bool explicitContext__)
        {
            if(explicitContext__ && context__ == null)
            {
                context__ = emptyContext_;
            }
            Ice.Instrumentation.InvocationObserver observer__ = IceInternal.ObserverHelper.get(this, __getProperty_name, context__);
            int cnt__ = 0;
            try
            {
                while(true)
                {
                    Ice.ObjectDel_ delBase__ = null;
                    try
                    {
                        checkTwowayOnly__(__getProperty_name);
                        delBase__ = getDelegate__(false);
                        PropertiesAdminDel_ del__ = (PropertiesAdminDel_)delBase__;
                        return del__.getProperty(key, context__, observer__);
                    }
                    catch(IceInternal.LocalExceptionWrapper ex__)
                    {
                        handleExceptionWrapper__(delBase__, ex__, observer__);
                    }
                    catch(Ice.LocalException ex__)
                    {
                        handleException__(delBase__, ex__, true, ref cnt__, observer__);
                    }
                }
            }
            finally
            {
                if(observer__ != null)
                {
                    observer__.detach();
                }
            }
        }

        /// <summary>
        /// Update the communicator's properties with the given property set.
        /// </summary>
        /// <param name="newProperties">Properties to be added, changed, or removed.
        /// If an entry in newProperties matches the name of an existing property,
        /// that property's value is replaced with the new value. If the new value
        /// is an empty string, the property is removed. Any existing properties
        /// that are not modified or removed by the entries in newProperties are
        /// retained with their original values.</param>
        
        public void setProperties(_System.Collections.Generic.Dictionary<string, string> newProperties)
        {
            setProperties(newProperties, null, false);
        }

        /// <summary>
        /// Update the communicator's properties with the given property set.
        /// </summary>
        /// <param name="newProperties">Properties to be added, changed, or removed.
        /// If an entry in newProperties matches the name of an existing property,
        /// that property's value is replaced with the new value. If the new value
        /// is an empty string, the property is removed. Any existing properties
        /// that are not modified or removed by the entries in newProperties are
        /// retained with their original values.</param>
        /// <param name="context__">The Context map to send with the invocation.</param>
        
        public void setProperties(_System.Collections.Generic.Dictionary<string, string> newProperties, _System.Collections.Generic.Dictionary<string, string> context__)
        {
            setProperties(newProperties, context__, true);
        }

        private void setProperties(_System.Collections.Generic.Dictionary<string, string> newProperties, _System.Collections.Generic.Dictionary<string, string> context__, bool explicitContext__)
        {
            if(explicitContext__ && context__ == null)
            {
                context__ = emptyContext_;
            }
            Ice.Instrumentation.InvocationObserver observer__ = IceInternal.ObserverHelper.get(this, __setProperties_name, context__);
            int cnt__ = 0;
            try
            {
                while(true)
                {
                    Ice.ObjectDel_ delBase__ = null;
                    try
                    {
                        delBase__ = getDelegate__(false);
                        PropertiesAdminDel_ del__ = (PropertiesAdminDel_)delBase__;
                        del__.setProperties(newProperties, context__, observer__);
                        return;
                    }
                    catch(IceInternal.LocalExceptionWrapper ex__)
                    {
                        handleExceptionWrapper__(delBase__, ex__, observer__);
                    }
                    catch(Ice.LocalException ex__)
                    {
                        handleException__(delBase__, ex__, true, ref cnt__, observer__);
                    }
                }
            }
            finally
            {
                if(observer__ != null)
                {
                    observer__.detach();
                }
            }
        }

        #endregion

        #region Asynchronous operations

        public Ice.AsyncResult<Ice.Callback_PropertiesAdmin_getPropertiesForPrefix> begin_getPropertiesForPrefix(string prefix)
        {
            return begin_getPropertiesForPrefix(prefix, null, false, null, null);
        }

        /// <summary>
        /// Get all properties whose keys begin with prefix.
        /// If
        /// </summary>
        /// <param name="prefix">The prefix to search for (empty string if none).
        /// </param>
        /// <param name="ctx__">The Context map to send with the invocation.</param>
        public Ice.AsyncResult<Ice.Callback_PropertiesAdmin_getPropertiesForPrefix> begin_getPropertiesForPrefix(string prefix, _System.Collections.Generic.Dictionary<string, string> ctx__)
        {
            return begin_getPropertiesForPrefix(prefix, ctx__, true, null, null);
        }

        public Ice.AsyncResult begin_getPropertiesForPrefix(string prefix, Ice.AsyncCallback cb__, object cookie__)
        {
            return begin_getPropertiesForPrefix(prefix, null, false, cb__, cookie__);
        }

        public Ice.AsyncResult begin_getPropertiesForPrefix(string prefix, _System.Collections.Generic.Dictionary<string, string> ctx__, Ice.AsyncCallback cb__, object cookie__)
        {
            return begin_getPropertiesForPrefix(prefix, ctx__, true, cb__, cookie__);
        }

        private const string __getPropertiesForPrefix_name = "getPropertiesForPrefix";

        public _System.Collections.Generic.Dictionary<string, string> end_getPropertiesForPrefix(Ice.AsyncResult r__)
        {
            IceInternal.OutgoingAsync outAsync__ = (IceInternal.OutgoingAsync)r__;
            IceInternal.OutgoingAsync.check__(outAsync__, this, __getPropertiesForPrefix_name);
            bool ok__ = outAsync__.wait__();
            try
            {
                if(!ok__)
                {
                    try
                    {
                        outAsync__.throwUserException__();
                    }
                    catch(Ice.UserException ex__)
                    {
                        throw new Ice.UnknownUserException(ex__.ice_name(), ex__);
                    }
                }
                _System.Collections.Generic.Dictionary<string, string> ret__;
                IceInternal.BasicStream is__ = outAsync__.startReadParams__();
                ret__ = Ice.PropertyDictHelper.read(is__);
                outAsync__.endReadParams__();
                return ret__;
            }
            catch(Ice.LocalException ex)
            {
                Ice.Instrumentation.InvocationObserver obsv__ = outAsync__.getObserver__();
                if(obsv__ != null)
                {
                    obsv__.failed(ex.ice_name());
                }
                throw ex;
            }
        }

        private Ice.AsyncResult<Ice.Callback_PropertiesAdmin_getPropertiesForPrefix> begin_getPropertiesForPrefix(string prefix, _System.Collections.Generic.Dictionary<string, string> ctx__, bool explicitContext__, Ice.AsyncCallback cb__, object cookie__)
        {
            checkAsyncTwowayOnly__(__getPropertiesForPrefix_name);
            IceInternal.TwowayOutgoingAsync<Ice.Callback_PropertiesAdmin_getPropertiesForPrefix> result__ =  new IceInternal.TwowayOutgoingAsync<Ice.Callback_PropertiesAdmin_getPropertiesForPrefix>(this, __getPropertiesForPrefix_name, getPropertiesForPrefix_completed__, cookie__);
            if(cb__ != null)
            {
                result__.whenCompletedWithAsyncCallback(cb__);
            }
            try
            {
                result__.prepare__(__getPropertiesForPrefix_name, Ice.OperationMode.Normal, ctx__, explicitContext__);
                IceInternal.BasicStream os__ = result__.startWriteParams__(Ice.FormatType.DefaultFormat);
                os__.writeString(prefix);
                result__.endWriteParams__();
                result__.send__(true);
            }
            catch(Ice.LocalException ex__)
            {
                result__.exceptionAsync__(ex__);
            }
            return result__;
        }

        private void getPropertiesForPrefix_completed__(Ice.AsyncResult r__, Ice.Callback_PropertiesAdmin_getPropertiesForPrefix cb__, Ice.ExceptionCallback excb__)
        {
            _System.Collections.Generic.Dictionary<string, string> ret__;
            try
            {
                ret__ = end_getPropertiesForPrefix(r__);
            }
            catch(Ice.Exception ex__)
            {
                if(excb__ != null)
                {
                    excb__(ex__);
                }
                return;
            }
            if(cb__ != null)
            {
                cb__(ret__);
            }
        }

        public Ice.AsyncResult<Ice.Callback_PropertiesAdmin_getProperty> begin_getProperty(string key)
        {
            return begin_getProperty(key, null, false, null, null);
        }

        /// <summary>
        /// Get a property by key.
        /// If the property is not set, an empty
        /// </summary>
        /// <param name="key">The property key.
        /// 
        /// </param>
        /// <param name="ctx__">The Context map to send with the invocation.</param>
        public Ice.AsyncResult<Ice.Callback_PropertiesAdmin_getProperty> begin_getProperty(string key, _System.Collections.Generic.Dictionary<string, string> ctx__)
        {
            return begin_getProperty(key, ctx__, true, null, null);
        }

        public Ice.AsyncResult begin_getProperty(string key, Ice.AsyncCallback cb__, object cookie__)
        {
            return begin_getProperty(key, null, false, cb__, cookie__);
        }

        public Ice.AsyncResult begin_getProperty(string key, _System.Collections.Generic.Dictionary<string, string> ctx__, Ice.AsyncCallback cb__, object cookie__)
        {
            return begin_getProperty(key, ctx__, true, cb__, cookie__);
        }

        private const string __getProperty_name = "getProperty";

        public string end_getProperty(Ice.AsyncResult r__)
        {
            IceInternal.OutgoingAsync outAsync__ = (IceInternal.OutgoingAsync)r__;
            IceInternal.OutgoingAsync.check__(outAsync__, this, __getProperty_name);
            bool ok__ = outAsync__.wait__();
            try
            {
                if(!ok__)
                {
                    try
                    {
                        outAsync__.throwUserException__();
                    }
                    catch(Ice.UserException ex__)
                    {
                        throw new Ice.UnknownUserException(ex__.ice_name(), ex__);
                    }
                }
                string ret__;
                IceInternal.BasicStream is__ = outAsync__.startReadParams__();
                ret__ = is__.readString();
                outAsync__.endReadParams__();
                return ret__;
            }
            catch(Ice.LocalException ex)
            {
                Ice.Instrumentation.InvocationObserver obsv__ = outAsync__.getObserver__();
                if(obsv__ != null)
                {
                    obsv__.failed(ex.ice_name());
                }
                throw ex;
            }
        }

        private Ice.AsyncResult<Ice.Callback_PropertiesAdmin_getProperty> begin_getProperty(string key, _System.Collections.Generic.Dictionary<string, string> ctx__, bool explicitContext__, Ice.AsyncCallback cb__, object cookie__)
        {
            checkAsyncTwowayOnly__(__getProperty_name);
            IceInternal.TwowayOutgoingAsync<Ice.Callback_PropertiesAdmin_getProperty> result__ =  new IceInternal.TwowayOutgoingAsync<Ice.Callback_PropertiesAdmin_getProperty>(this, __getProperty_name, getProperty_completed__, cookie__);
            if(cb__ != null)
            {
                result__.whenCompletedWithAsyncCallback(cb__);
            }
            try
            {
                result__.prepare__(__getProperty_name, Ice.OperationMode.Normal, ctx__, explicitContext__);
                IceInternal.BasicStream os__ = result__.startWriteParams__(Ice.FormatType.DefaultFormat);
                os__.writeString(key);
                result__.endWriteParams__();
                result__.send__(true);
            }
            catch(Ice.LocalException ex__)
            {
                result__.exceptionAsync__(ex__);
            }
            return result__;
        }

        private void getProperty_completed__(Ice.AsyncResult r__, Ice.Callback_PropertiesAdmin_getProperty cb__, Ice.ExceptionCallback excb__)
        {
            string ret__;
            try
            {
                ret__ = end_getProperty(r__);
            }
            catch(Ice.Exception ex__)
            {
                if(excb__ != null)
                {
                    excb__(ex__);
                }
                return;
            }
            if(cb__ != null)
            {
                cb__(ret__);
            }
        }

        public Ice.AsyncResult<Ice.Callback_PropertiesAdmin_setProperties> begin_setProperties(_System.Collections.Generic.Dictionary<string, string> newProperties)
        {
            return begin_setProperties(newProperties, null, false, null, null);
        }

        /// <summary>
        /// Update the communicator's properties with the given property set.
        /// </summary>
        /// <param name="newProperties">Properties to be added, changed, or removed.
        /// If an entry in newProperties matches the name of an existing property,
        /// that property's value is replaced with the new value. If the new value
        /// is an empty string, the property is removed. Any existing properties
        /// that are not modified or removed by the entries in newProperties are
        /// retained with their original values.</param>
        /// <param name="ctx__">The Context map to send with the invocation.</param>
        public Ice.AsyncResult<Ice.Callback_PropertiesAdmin_setProperties> begin_setProperties(_System.Collections.Generic.Dictionary<string, string> newProperties, _System.Collections.Generic.Dictionary<string, string> ctx__)
        {
            return begin_setProperties(newProperties, ctx__, true, null, null);
        }

        public Ice.AsyncResult begin_setProperties(_System.Collections.Generic.Dictionary<string, string> newProperties, Ice.AsyncCallback cb__, object cookie__)
        {
            return begin_setProperties(newProperties, null, false, cb__, cookie__);
        }

        public Ice.AsyncResult begin_setProperties(_System.Collections.Generic.Dictionary<string, string> newProperties, _System.Collections.Generic.Dictionary<string, string> ctx__, Ice.AsyncCallback cb__, object cookie__)
        {
            return begin_setProperties(newProperties, ctx__, true, cb__, cookie__);
        }

        private const string __setProperties_name = "setProperties";

        public void end_setProperties(Ice.AsyncResult r__)
        {
            end__(r__, __setProperties_name);
        }

        private Ice.AsyncResult<Ice.Callback_PropertiesAdmin_setProperties> begin_setProperties(_System.Collections.Generic.Dictionary<string, string> newProperties, _System.Collections.Generic.Dictionary<string, string> ctx__, bool explicitContext__, Ice.AsyncCallback cb__, object cookie__)
        {
            IceInternal.OnewayOutgoingAsync<Ice.Callback_PropertiesAdmin_setProperties> result__ = new IceInternal.OnewayOutgoingAsync<Ice.Callback_PropertiesAdmin_setProperties>(this, __setProperties_name, setProperties_completed__, cookie__);
            if(cb__ != null)
            {
                result__.whenCompletedWithAsyncCallback(cb__);
            }
            try
            {
                result__.prepare__(__setProperties_name, Ice.OperationMode.Normal, ctx__, explicitContext__);
                IceInternal.BasicStream os__ = result__.startWriteParams__(Ice.FormatType.DefaultFormat);
                Ice.PropertyDictHelper.write(os__, newProperties);
                result__.endWriteParams__();
                result__.send__(true);
            }
            catch(Ice.LocalException ex__)
            {
                result__.exceptionAsync__(ex__);
            }
            return result__;
        }

        private void setProperties_completed__(Ice.Callback_PropertiesAdmin_setProperties cb__)
        {
            if(cb__ != null)
            {
                cb__();
            }
        }

        #endregion

        #region Checked and unchecked cast operations

        public static PropertiesAdminPrx checkedCast(Ice.ObjectPrx b)
        {
            if(b == null)
            {
                return null;
            }
            PropertiesAdminPrx r = b as PropertiesAdminPrx;
            if((r == null) && b.ice_isA(ice_staticId()))
            {
                PropertiesAdminPrxHelper h = new PropertiesAdminPrxHelper();
                h.copyFrom__(b);
                r = h;
            }
            return r;
        }

        public static PropertiesAdminPrx checkedCast(Ice.ObjectPrx b, _System.Collections.Generic.Dictionary<string, string> ctx)
        {
            if(b == null)
            {
                return null;
            }
            PropertiesAdminPrx r = b as PropertiesAdminPrx;
            if((r == null) && b.ice_isA(ice_staticId(), ctx))
            {
                PropertiesAdminPrxHelper h = new PropertiesAdminPrxHelper();
                h.copyFrom__(b);
                r = h;
            }
            return r;
        }

        public static PropertiesAdminPrx checkedCast(Ice.ObjectPrx b, string f)
        {
            if(b == null)
            {
                return null;
            }
            Ice.ObjectPrx bb = b.ice_facet(f);
            try
            {
                if(bb.ice_isA(ice_staticId()))
                {
                    PropertiesAdminPrxHelper h = new PropertiesAdminPrxHelper();
                    h.copyFrom__(bb);
                    return h;
                }
            }
            catch(Ice.FacetNotExistException)
            {
            }
            return null;
        }

        public static PropertiesAdminPrx checkedCast(Ice.ObjectPrx b, string f, _System.Collections.Generic.Dictionary<string, string> ctx)
        {
            if(b == null)
            {
                return null;
            }
            Ice.ObjectPrx bb = b.ice_facet(f);
            try
            {
                if(bb.ice_isA(ice_staticId(), ctx))
                {
                    PropertiesAdminPrxHelper h = new PropertiesAdminPrxHelper();
                    h.copyFrom__(bb);
                    return h;
                }
            }
            catch(Ice.FacetNotExistException)
            {
            }
            return null;
        }

        public static PropertiesAdminPrx uncheckedCast(Ice.ObjectPrx b)
        {
            if(b == null)
            {
                return null;
            }
            PropertiesAdminPrx r = b as PropertiesAdminPrx;
            if(r == null)
            {
                PropertiesAdminPrxHelper h = new PropertiesAdminPrxHelper();
                h.copyFrom__(b);
                r = h;
            }
            return r;
        }

        public static PropertiesAdminPrx uncheckedCast(Ice.ObjectPrx b, string f)
        {
            if(b == null)
            {
                return null;
            }
            Ice.ObjectPrx bb = b.ice_facet(f);
            PropertiesAdminPrxHelper h = new PropertiesAdminPrxHelper();
            h.copyFrom__(bb);
            return h;
        }

        public static readonly string[] ids__ =
        {
            "::Ice::Object",
            "::Ice::PropertiesAdmin"
        };

        public static string ice_staticId()
        {
            return ids__[1];
        }

        #endregion

        #region Marshaling support

        protected override Ice.ObjectDelM_ createDelegateM__()
        {
            return new PropertiesAdminDelM_();
        }

        protected override Ice.ObjectDelD_ createDelegateD__()
        {
            return new PropertiesAdminDelD_();
        }

        public static void write__(IceInternal.BasicStream os__, PropertiesAdminPrx v__)
        {
            os__.writeProxy(v__);
        }

        public static PropertiesAdminPrx read__(IceInternal.BasicStream is__)
        {
            Ice.ObjectPrx proxy = is__.readProxy();
            if(proxy != null)
            {
                PropertiesAdminPrxHelper result = new PropertiesAdminPrxHelper();
                result.copyFrom__(proxy);
                return result;
            }
            return null;
        }

        #endregion
    }
}

namespace Ice
{
    [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
    public interface PropertiesAdminDel_ : Ice.ObjectDel_
    {
        string getProperty(string key, _System.Collections.Generic.Dictionary<string, string> context__, Ice.Instrumentation.InvocationObserver observer__);

        _System.Collections.Generic.Dictionary<string, string> getPropertiesForPrefix(string prefix, _System.Collections.Generic.Dictionary<string, string> context__, Ice.Instrumentation.InvocationObserver observer__);

        void setProperties(_System.Collections.Generic.Dictionary<string, string> newProperties, _System.Collections.Generic.Dictionary<string, string> context__, Ice.Instrumentation.InvocationObserver observer__);
    }
}

namespace Ice
{
    [_System.Runtime.InteropServices.ComVisible(false)]
    [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
    public sealed class PropertiesAdminDelM_ : Ice.ObjectDelM_, PropertiesAdminDel_
    {
        public _System.Collections.Generic.Dictionary<string, string> getPropertiesForPrefix(string prefix, _System.Collections.Generic.Dictionary<string, string> context__, Ice.Instrumentation.InvocationObserver observer__)
        {
            IceInternal.Outgoing og__ = handler__.getOutgoing("getPropertiesForPrefix", Ice.OperationMode.Normal, context__, observer__);
            try
            {
                try
                {
                    IceInternal.BasicStream os__ = og__.startWriteParams(Ice.FormatType.DefaultFormat);
                    os__.writeString(prefix);
                    og__.endWriteParams();
                }
                catch(Ice.LocalException ex__)
                {
                    og__.abort(ex__);
                }
                bool ok__ = og__.invoke();
                try
                {
                    if(!ok__)
                    {
                        try
                        {
                            og__.throwUserException();
                        }
                        catch(Ice.UserException ex__)
                        {
                            throw new Ice.UnknownUserException(ex__.ice_name(), ex__);
                        }
                    }
                    IceInternal.BasicStream is__ = og__.startReadParams();
                    _System.Collections.Generic.Dictionary<string, string> ret__;
                    ret__ = Ice.PropertyDictHelper.read(is__);
                    og__.endReadParams();
                    return ret__;
                }
                catch(Ice.LocalException ex__)
                {
                    throw new IceInternal.LocalExceptionWrapper(ex__, false);
                }
            }
            finally
            {
                handler__.reclaimOutgoing(og__);
            }
        }

        public string getProperty(string key, _System.Collections.Generic.Dictionary<string, string> context__, Ice.Instrumentation.InvocationObserver observer__)
        {
            IceInternal.Outgoing og__ = handler__.getOutgoing("getProperty", Ice.OperationMode.Normal, context__, observer__);
            try
            {
                try
                {
                    IceInternal.BasicStream os__ = og__.startWriteParams(Ice.FormatType.DefaultFormat);
                    os__.writeString(key);
                    og__.endWriteParams();
                }
                catch(Ice.LocalException ex__)
                {
                    og__.abort(ex__);
                }
                bool ok__ = og__.invoke();
                try
                {
                    if(!ok__)
                    {
                        try
                        {
                            og__.throwUserException();
                        }
                        catch(Ice.UserException ex__)
                        {
                            throw new Ice.UnknownUserException(ex__.ice_name(), ex__);
                        }
                    }
                    IceInternal.BasicStream is__ = og__.startReadParams();
                    string ret__;
                    ret__ = is__.readString();
                    og__.endReadParams();
                    return ret__;
                }
                catch(Ice.LocalException ex__)
                {
                    throw new IceInternal.LocalExceptionWrapper(ex__, false);
                }
            }
            finally
            {
                handler__.reclaimOutgoing(og__);
            }
        }

        public void setProperties(_System.Collections.Generic.Dictionary<string, string> newProperties, _System.Collections.Generic.Dictionary<string, string> context__, Ice.Instrumentation.InvocationObserver observer__)
        {
            IceInternal.Outgoing og__ = handler__.getOutgoing("setProperties", Ice.OperationMode.Normal, context__, observer__);
            try
            {
                try
                {
                    IceInternal.BasicStream os__ = og__.startWriteParams(Ice.FormatType.DefaultFormat);
                    Ice.PropertyDictHelper.write(os__, newProperties);
                    og__.endWriteParams();
                }
                catch(Ice.LocalException ex__)
                {
                    og__.abort(ex__);
                }
                bool ok__ = og__.invoke();
                if(og__.hasResponse())
                {
                    try
                    {
                        if(!ok__)
                        {
                            try
                            {
                                og__.throwUserException();
                            }
                            catch(Ice.UserException ex__)
                            {
                                throw new Ice.UnknownUserException(ex__.ice_name(), ex__);
                            }
                        }
                        og__.readEmptyParams();
                    }
                    catch(Ice.LocalException ex__)
                    {
                        throw new IceInternal.LocalExceptionWrapper(ex__, false);
                    }
                }
            }
            finally
            {
                handler__.reclaimOutgoing(og__);
            }
        }
    }
}

namespace Ice
{
    [_System.Runtime.InteropServices.ComVisible(false)]
    [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
    public sealed class PropertiesAdminDelD_ : Ice.ObjectDelD_, PropertiesAdminDel_
    {
        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1031")]
        public _System.Collections.Generic.Dictionary<string, string> getPropertiesForPrefix(string prefix, _System.Collections.Generic.Dictionary<string, string> context__, Ice.Instrumentation.InvocationObserver observer__)
        {
            Ice.Current current__ = new Ice.Current();
            initCurrent__(ref current__, "getPropertiesForPrefix", Ice.OperationMode.Normal, context__);
            _System.Collections.Generic.Dictionary<string, string> result__ = null;
            IceInternal.Direct.RunDelegate run__ = delegate(Ice.Object obj__)
            {
                PropertiesAdmin servant__ = null;
                try
                {
                    servant__ = (PropertiesAdmin)obj__;
                }
                catch(_System.InvalidCastException)
                {
                    throw new Ice.OperationNotExistException(current__.id, current__.facet, current__.operation);
                }
                result__ = servant__.getPropertiesForPrefix(prefix, current__);
                return Ice.DispatchStatus.DispatchOK;
            };
            IceInternal.Direct direct__ = null;
            try
            {
                direct__ = new IceInternal.Direct(current__, run__);
                try
                {
                    Ice.DispatchStatus status__ = direct__.getServant().collocDispatch__(direct__);
                    _System.Diagnostics.Debug.Assert(status__ == Ice.DispatchStatus.DispatchOK);
                }
                finally
                {
                    direct__.destroy();
                }
            }
            catch(Ice.SystemException)
            {
                throw;
            }
            catch(_System.Exception ex__)
            {
                IceInternal.LocalExceptionWrapper.throwWrapper(ex__);
            }
            return result__;
        }

        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1031")]
        public string getProperty(string key, _System.Collections.Generic.Dictionary<string, string> context__, Ice.Instrumentation.InvocationObserver observer__)
        {
            Ice.Current current__ = new Ice.Current();
            initCurrent__(ref current__, "getProperty", Ice.OperationMode.Normal, context__);
            string result__ = null;
            IceInternal.Direct.RunDelegate run__ = delegate(Ice.Object obj__)
            {
                PropertiesAdmin servant__ = null;
                try
                {
                    servant__ = (PropertiesAdmin)obj__;
                }
                catch(_System.InvalidCastException)
                {
                    throw new Ice.OperationNotExistException(current__.id, current__.facet, current__.operation);
                }
                result__ = servant__.getProperty(key, current__);
                return Ice.DispatchStatus.DispatchOK;
            };
            IceInternal.Direct direct__ = null;
            try
            {
                direct__ = new IceInternal.Direct(current__, run__);
                try
                {
                    Ice.DispatchStatus status__ = direct__.getServant().collocDispatch__(direct__);
                    _System.Diagnostics.Debug.Assert(status__ == Ice.DispatchStatus.DispatchOK);
                }
                finally
                {
                    direct__.destroy();
                }
            }
            catch(Ice.SystemException)
            {
                throw;
            }
            catch(_System.Exception ex__)
            {
                IceInternal.LocalExceptionWrapper.throwWrapper(ex__);
            }
            return result__;
        }

        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1031")]
        public void setProperties(_System.Collections.Generic.Dictionary<string, string> newProperties, _System.Collections.Generic.Dictionary<string, string> context__, Ice.Instrumentation.InvocationObserver observer__)
        {
            throw new Ice.CollocationOptimizationException();
        }
    }
}

namespace Ice
{
    [_System.Runtime.InteropServices.ComVisible(false)]
    [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
    public abstract class PropertiesAdminDisp_ : Ice.ObjectImpl, PropertiesAdmin
    {
        #region Slice operations

        public string getProperty(string key)
        {
            return getProperty(key, Ice.ObjectImpl.defaultCurrent);
        }

        public abstract string getProperty(string key, Ice.Current current__);

        public _System.Collections.Generic.Dictionary<string, string> getPropertiesForPrefix(string prefix)
        {
            return getPropertiesForPrefix(prefix, Ice.ObjectImpl.defaultCurrent);
        }

        public abstract _System.Collections.Generic.Dictionary<string, string> getPropertiesForPrefix(string prefix, Ice.Current current__);

        public void setProperties_async(Ice.AMD_PropertiesAdmin_setProperties cb__, _System.Collections.Generic.Dictionary<string, string> newProperties)
        {
            setProperties_async(cb__, newProperties, Ice.ObjectImpl.defaultCurrent);
        }

        public abstract void setProperties_async(Ice.AMD_PropertiesAdmin_setProperties cb__, _System.Collections.Generic.Dictionary<string, string> newProperties, Ice.Current current__);

        #endregion

        #region Slice type-related members

        public static new readonly string[] ids__ = 
        {
            "::Ice::Object",
            "::Ice::PropertiesAdmin"
        };

        public override bool ice_isA(string s)
        {
            return _System.Array.BinarySearch(ids__, s, IceUtilInternal.StringUtil.OrdinalStringComparer) >= 0;
        }

        public override bool ice_isA(string s, Ice.Current current__)
        {
            return _System.Array.BinarySearch(ids__, s, IceUtilInternal.StringUtil.OrdinalStringComparer) >= 0;
        }

        public override string[] ice_ids()
        {
            return ids__;
        }

        public override string[] ice_ids(Ice.Current current__)
        {
            return ids__;
        }

        public override string ice_id()
        {
            return ids__[1];
        }

        public override string ice_id(Ice.Current current__)
        {
            return ids__[1];
        }

        public static new string ice_staticId()
        {
            return ids__[1];
        }

        #endregion

        #region Operation dispatch

        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1011")]
        public static Ice.DispatchStatus getProperty___(PropertiesAdmin obj__, IceInternal.Incoming inS__, Ice.Current current__)
        {
            checkMode__(Ice.OperationMode.Normal, current__.mode);
            IceInternal.BasicStream is__ = inS__.startReadParams();
            string key;
            key = is__.readString();
            inS__.endReadParams();
            string ret__ = obj__.getProperty(key, current__);
            IceInternal.BasicStream os__ = inS__.startWriteParams__(Ice.FormatType.DefaultFormat);
            os__.writeString(ret__);
            inS__.endWriteParams__(true);
            return Ice.DispatchStatus.DispatchOK;
        }

        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1011")]
        public static Ice.DispatchStatus getPropertiesForPrefix___(PropertiesAdmin obj__, IceInternal.Incoming inS__, Ice.Current current__)
        {
            checkMode__(Ice.OperationMode.Normal, current__.mode);
            IceInternal.BasicStream is__ = inS__.startReadParams();
            string prefix;
            prefix = is__.readString();
            inS__.endReadParams();
            _System.Collections.Generic.Dictionary<string, string> ret__ = obj__.getPropertiesForPrefix(prefix, current__);
            IceInternal.BasicStream os__ = inS__.startWriteParams__(Ice.FormatType.DefaultFormat);
            Ice.PropertyDictHelper.write(os__, ret__);
            inS__.endWriteParams__(true);
            return Ice.DispatchStatus.DispatchOK;
        }

        [_System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1011")]
        public static Ice.DispatchStatus setProperties___(PropertiesAdmin obj__, IceInternal.Incoming inS__, Ice.Current current__)
        {
            checkMode__(Ice.OperationMode.Normal, current__.mode);
            IceInternal.BasicStream is__ = inS__.startReadParams();
            _System.Collections.Generic.Dictionary<string, string> newProperties;
            newProperties = Ice.PropertyDictHelper.read(is__);
            inS__.endReadParams();
            AMD_PropertiesAdmin_setProperties cb__ = new _AMD_PropertiesAdmin_setProperties(inS__);
            try
            {
                obj__.setProperties_async(cb__, newProperties, current__);
            }
            catch(_System.Exception ex__)
            {
                cb__.ice_exception(ex__);
            }
            return Ice.DispatchStatus.DispatchAsync;
        }

        private static string[] all__ =
        {
            "getPropertiesForPrefix",
            "getProperty",
            "ice_id",
            "ice_ids",
            "ice_isA",
            "ice_ping",
            "setProperties"
        };

        public override Ice.DispatchStatus dispatch__(IceInternal.Incoming inS__, Ice.Current current__)
        {
            int pos = _System.Array.BinarySearch(all__, current__.operation, IceUtilInternal.StringUtil.OrdinalStringComparer);
            if(pos < 0)
            {
                throw new Ice.OperationNotExistException(current__.id, current__.facet, current__.operation);
            }

            switch(pos)
            {
                case 0:
                {
                    return getPropertiesForPrefix___(this, inS__, current__);
                }
                case 1:
                {
                    return getProperty___(this, inS__, current__);
                }
                case 2:
                {
                    return ice_id___(this, inS__, current__);
                }
                case 3:
                {
                    return ice_ids___(this, inS__, current__);
                }
                case 4:
                {
                    return ice_isA___(this, inS__, current__);
                }
                case 5:
                {
                    return ice_ping___(this, inS__, current__);
                }
                case 6:
                {
                    return setProperties___(this, inS__, current__);
                }
            }

            _System.Diagnostics.Debug.Assert(false);
            throw new Ice.OperationNotExistException(current__.id, current__.facet, current__.operation);
        }

        #endregion

        #region Marshaling support

        protected override void writeImpl__(IceInternal.BasicStream os__)
        {
            os__.startWriteSlice(ice_staticId(), -1, true);
            os__.endWriteSlice();
        }

        protected override void readImpl__(IceInternal.BasicStream is__)
        {
            is__.startReadSlice();
            is__.endReadSlice();
        }

        #endregion
    }
}

namespace Ice
{
    /// <summary>
    /// Update the communicator's properties with the given property set.
    /// </summary>
    [_System.Runtime.InteropServices.ComVisible(false)]
    [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
    public interface AMD_PropertiesAdmin_setProperties : Ice.AMDCallback
    {
        /// <summary>
        /// ice_response indicates that
        /// the operation completed successfully.
        /// </summary>
        void ice_response();
    }

    [_System.CodeDom.Compiler.GeneratedCodeAttribute("slice2cs", "3.5.0")]
    class _AMD_PropertiesAdmin_setProperties : IceInternal.IncomingAsync, AMD_PropertiesAdmin_setProperties
    {
        public _AMD_PropertiesAdmin_setProperties(IceInternal.Incoming inc) : base(inc)
        {
        }

        public void ice_response()
        {
            if(validateResponse__(true))
            {
                writeEmptyParams__();
                response__();
            }
        }
    }
}
