﻿using Ice;
using System;

namespace Server
{
    class Program
    {
        static void Main()
        {
            try
            {
                Communicator comm = Util.initialize();
                comm.getProperties().setProperty("Ice.ThreadPool.Server.SizeMax", "5");

                ObjectAdapter adapter = comm.createObjectAdapterWithEndpoints("Hello", "tcp -p 10000");
                adapter.add(new HelloI(), comm.stringToIdentity("hello"));
                adapter.activate();

                Console.WriteLine("Server started...");

                comm.waitForShutdown();
                comm.destroy();
            }
            catch (System.Exception ex)
            {
                Console.WriteLine(ex.Message);
            }
        }
    }
}
